dojo.provide("com.ibm.mm.builder.systemwidget.ContentSetList");
dojo.require("com.ibm.pb.iwidget.iWidgetBase");
dojo.declare("com.ibm.mm.builder.systemwidget.ContentSetList",[com.ibm.pb.iwidget.iWidgetBase],{listCSSClass:"",initEvent:"",targetDOMNode:null,contextMenuID:"",resourceType:"",constructor:function(){
this._listConnections=[];
},getData:function(_1){
var _2="getData",_3=this.LOGGER;
_3.entering(_2,arguments);
var _4=this.builderFactory.getContextMenuModel();
var _5=_4.getContextMenu(this.contextMenuID,_1,this.resourceType,{context:this});
_3.exiting(_2,[_5]);
return _5;
},onLoad:function(){
var _6="onLoad",_7=this.LOGGER;
_7.entering(_6,arguments);
this.inherited(arguments);
dojo.mixin(this,this.getItemSetValues(["contextMenuID","resourceType","resourceId","init_resourceId","listCSSClass","targetDOMNode","initEvent"]));
if(!this.resourceId&&this.init_resourceId){
this.resourceId=dojo.eval(this.init_resourceId);
}
_7.trace(_6,"Loaded ${0} with resourceId %{1}",[this,this.resourceId]);
this.targetDOMNode=dojo.byId(this.targetDOMNode);
if(!this.targetDOMNode){
this.targetDOMNode=this.iContext.getRootElement();
this.listNode=dojo.create("ul",{},this.targetDOMNode);
}else{
this.listNode=dojo.query("ul",this.targetDOMNode)[0];
}
if(this.listCSSClass){
dojo.addClass(this.listNode,this.listCSSClass);
}
this.init(this.resourceId);
if(this.initEvent){
this.evtSvc.subscribeEvent(this.initEvent,this,"init");
}
var _8=com.ibm.mashups.services.ServiceManager.getService("eventService");
_8.broadcastEvent("com.ibm.mashups.builder.refreshSpaceSelector");
_7.exiting(_6,arguments);
},init:function(_9){
this.resourceId=_9;
if(!this.refNode){
this.refNode=dojo.query("li.content",this.listNode)[0];
if(!this.refNode){
this.refNode=dojo.create("li",{"class":"content",style:{"display":"none"}},this.listNode);
}
}
dojo.query("> .content-set-item",this.listNode).forEach(dojo.destroy,dojo);
this.buildList();
},buildList:function(){
var _a="buildList",_b=this.LOGGER;
_b.entering(_a,arguments);
while(this._listConnections.length>0){
dojo.disconnect(this._listConnections.shift());
}
var _c=this.getData(this.resourceId);
dojo.forEach(_c,function(_d){
var li=dojo.create("li",{"class":"content-set-item","id":_d.id},this.refNode,"before");
if(_d.markup){
li.innerHTML=dojo.string.substitute(_d.markup,{title:_d.title||"",description:_d.description||""});
}else{
var _e=dojo.create("a",{href:"javascript:;"},li);
_e.appendChild(document.createTextNode(_d.title));
}
if(_d.iconClass){
dojo.addClass(li,_d.iconClass);
}
this._listConnections.push(dojo.connect(li,"onclick",li,_d.actionCallBackFunction));
},this);
_b.exiting(_a,arguments);
},onUnload:function(){
while(this._listConnections.length>0){
dojo.disconnect(this._listConnections.shift());
}
}});

